﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_mersenne_primes
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            lstPrimes.Items.Clear();
            Cursor = Cursors.WaitCursor;
            Refresh();

            try
            {
                checked
                {
                    long power = 1;
                    for (int n = 1; n < 63; n++)
                    {
                        // Get the next power of 2.
                        power *= 2;

                        // See if power - 1 is prime.
                        if (IsMersennePrime(power - 1))
                        {
                            lstPrimes.Items.Add(
                                n.ToString() + ": " + (power - 1).ToString());
                            Refresh();
                        }
                    }
                }
            }
            catch
            {
            }

            Cursor = Cursors.Default;
        }

        // Return true if the number is prime.
        private bool IsMersennePrime(long number)
        {
            // See if the number is divisible by odd values up to Sqrt(number).
            long sqrt = (long)Math.Sqrt(number);
            for (long i = 3; i < sqrt; i += 2)
                if (number % i == 0) return false;

            // If we get here, the number is prime.
            return true;
        }
    }
}
